<template>
  <div>
    <el-main>
      <el-row class="align-left" style="margin:0px 0px 0px 0px;">
        <el-button v-on:click='EnterForum()' type="primary" plain>返回列表</el-button>
        <span class="text post-head" style="margin:0px 0px 0px 50px;">{{msg_data.msg_head}}</span>
        <el-button v-if='high_privelege' v-on:click='StickQuestion(!msg_data.msg_stick_state)' type="success" plain style="position:absolute;margin:0px 0px 0px 200px;">
          {{(!msg_data.msg_stick_state)?'置顶问题':'取消置顶'}}
        </el-button>
        <el-button v-if='high_privelege || cur_user == msg_data.msg_profile_id' v-on:click='delete_type=1;dialog_delete_vis=true' type="danger" plain style="position:absolute;margin:0px 0px 0px 320px;">删除问题</el-button>
      </el-row>
      <el-row>
        <el-divider></el-divider>
      </el-row>
      <el-row>
          <div class="msg-block align-left">
            <div class="inline" style="width:20%;">
              <el-avatar :size="50" :src='msg_data.msg_avatar' style="margin:10px 0px 0px 0px;"></el-avatar>
              <p class="post-username" style="margin:20px 0px 0px 0px;">{{msg_data.msg_profile_name}}</p>
            </div>
            <div class="inline" style="width:80%;">
              <p v-html='msg_data.msg_content' class="text post-content maxsize"></p>
              <div style="margin:40px 0px 0px 0px;">
                <span class="text post-time">{{msg_data.msg_time}}</span>
                <i class="el-icon-chat-line-round" style="margin:0px 0px 0px 400px;"></i>
                <span>{{msg_data.msg_reply_count}}</span>
                <i 
                  v-on:click="LikeQuestion(post_id,!msg_data.msg_like_state)"
                  class="el-icon-magic-stick like-icon" 
                  v-bind:class="{liked: msg_data.msg_like_state}"
                  style="margin:0px 0px 0px 20px;"
                ></i>
                <span>{{msg_data.msg_like_count}}</span>
              </div>
            </div>
          </div>
      </el-row>
      <el-row>
        <el-divider></el-divider>
      </el-row>

      <el-row v-for="item in reply_data" :key="item.reply_content">
        <!--key需修改/定位方式-->
          <div class="ans-block">
            <div class="align-left">
              <el-avatar :size="40" :src='item.reply_avatar' style="margin:0px 0px 0px 0px;"></el-avatar>
              <span class="post-username" style="position:absolute;margin:10px 0px 0px 50px;">{{item.reply_user_name}}</span>
              <span class="text post-time" style="position:absolute;margin:7px 0px 0px 150px;">{{item.reply_time}}</span>
              <el-button v-if='high_privelege || cur_user == item.reply_user_id' v-on:click='delete_type=2;delete_index=reply_data.indexOf(item);dialog_delete_vis=true' type="danger" plain style="margin:0px 0px 0px 550px;">删除回答</el-button>
            </div>
            <div>
              <p v-html='item.reply_content' class="text post-content maxsize" style="margin:30px 0px 0px 0px;"></p>
            </div>
            <div class="post-info">
                <i 
                  v-on:click="LikeReply(reply_data.indexOf(item),!item.reply_like_state)"
                  class="el-icon-magic-stick like-icon" 
                  v-bind:class="{liked: item.reply_like_state}"
                  style="margin:40px 0px 0px 550px;"
                ></i>
                <span>{{item.reply_like_count}}</span>
            </div>
          </div>
          <el-divider></el-divider>
      </el-row>

    <el-row>
      <el-col :span="20" :offset="2" type="flex" justify="center">
        <el-pagination background layout="prev, pager, next" :total='reply_count' @current-change='PageChange' ></el-pagination>
      </el-col>
    </el-row>

      <el-row v-if='!high_privelege' style="margin:20px 0px 0px 0px;">
        <el-col :span="18">
          <Toolbar :editor='editor' :mode='editor_mode' :defaultConfig='toolbar_config'
          style='border-bottom: 1px solid #ccc;' />
          <Editor v-model='reply_input' :mode='editor_mode' @onCreated='EditorCreated' :defaultConfig='editor_config'
          style='height:300px;overflow-y:hidden;text-align:left;' />
        </el-col>
        <el-col :span="6">
          <el-button v-on:click='AddReply()' type="success" plain style="margin:100px 0px 0px 0px;">回答问题</el-button>
        </el-col>
      </el-row>

    </el-main>

    <el-dialog  title='请确认是否删除' :visible.sync='dialog_delete_vis' width='30%'>
      <el-row v-if='high_privelege'>
          <el-col :span="16" :offset="4">
            <el-input placeholder="输入删除原因" v-model="delete_reason" 
            maxlength="30" clearable style="margin:0px 0px 0px 0px;"></el-input>
          </el-col>
      </el-row>
      <el-row>
          <el-col :span="12" :offset="6">
            <el-button v-on:click='DeleteExec();dialog_delete_vis=false' 
              type="success" plain style="margin:10px 0px 0px 0px;">确认删除</el-button>
            <el-button v-on:click='dialog_delete_vis=false' type="danger" plain style="margin:10px 0px 0px 20px;">取消</el-button>
          </el-col>
      </el-row>
    </el-dialog>
  </div>
</template>

<script>

import { Editor,Toolbar } from '@wangeditor/editor-for-vue';

export default 
{
  name: 'PostView',
  props:['pid'],
  data(){
    return
    {
      post_id: this.pid,
      class_id:'',

      search_input: '',
      reply_input: '',
      reply_image_list: [],
      
      msg_data:
      {
        msg_head:'消息标题',
        msg_content:'消息内容',
        msg_time:'发布时间',
        msg_profile_name:'用户名称',
        msg_reply_count:'0',
        msg_like_count:'0',
      },

      reply_data: [],
      reply_count: 1,

      page_size: 5,
      cur_page: 1,

      editor: null,
      editor_mode: 'simple',
      editor_config: 
      { 
        placeholder:'输入回答内容',maxLength:500,scroll:true,
        MENU_CONF:{ uploadImage:
        { 
          server: 'http://localhost:3000/api/upload/upload-image', fieldName:'images',
          onSuccess(file,res)
          {
            this.reply_image_list.push(file.name);
          }, }, }, },
      toolbar_config: { excludeKeys:[ 'insertVideo','fullScreen', ], },

      cur_user : this.$store.getters.getEmail.slice(0,7),
      high_privelege : this.$store.getters.getRole=='admin' || this.$store.getters.getRole=='teacher',

      dialog_delete_vis : false,
      delete_type : 0,
      delete_index : null,
      delete_reason : '',
    };
  },
  methods:{
    getAvatar(index,user_id,type)
    {
      this.$axios.get('/api/user/info',{
        params:{
          email : user_id + '@tongji.edu.cn',
        }
      })
        .then((response)=>
        {
          if(type==0)
          {
            this.msg_data.msg_avatar = response.data.data.avatar;
          }
          else
          {
            this.reply_data[index].reply_avatar = response.data.data.avatar;
          }
        })
        .catch((error)=>
        {
          console.log(error);
        });
    },
    getTime(timestamp)
    {
      var date = new Date(timestamp);
      return (date.getFullYear()+'-'+date.getMonth()+'-'+date.getDate());
    },
    EnterForum:function()
    {
      this.$emit('enterforum',this.class_id);
    },
    PageChange:function(page)
    {
      this.cur_page = page;
      this.GetReplyList();
    },
    EditorCreated(editor)
    {
      this.editor = Object.seal(editor);
    },
    DeleteExec()
    {
      if(this.delete_type==1)
      {
        this.DeleteQuestion();
      }
      else if(this.delete_type==2)
      {
        this.DeleteReply(this.delete_index);
      }
      this.delete_type = 0;
      this.delete_index = null;
      this.delete_reason = '';
    },


    GetReplyList:function()
    {
      this.$axios.get('/api/forum/get-reply',{
        params:
        {
          user_id : this.cur_user,
          question_id : this.post_id,
          idx_up : (this.cur_page-1)*this.page_size,
          idx_low : this.cur_page*this.page_size,
        }
      })
        .then((response)=>
        {
          let temp={
            msg_head : response.data.question.question_head,
            msg_content : response.data.question.question_content,
            msg_time : this.getTime(response.data.question.reply_timestamp),
            msg_profile_id :response.data.question.user_id,
            msg_profile_name :response.data.question.user_id,
            msg_reply_count : response.data.question.reply_count,
            msg_like_count : response.data.question.like_count,
            msg_like_state : response.data.question.like_state,
            msg_stick_state : response.data.question.stick_state,
            msg_avatar : '',
          };
          this.msg_data = temp;
          this.getAvatar(0,response.data.question.user_id,0);

          this.reply_count = response.data.reply_count;
          this.reply_data=[];
          let i=0;
          response.data.reply_list.forEach(element => {
            let temp =
            {
              reply_id: element.reply_id,
              reply_content : element.reply_content,
              reply_time : this.getTime(element.reply_timestamp),
              reply_user_id : element.user_id,
              reply_user_name : element.user_id,
              reply_like_count : element.like_count,
              reply_like_state : element.like_state,
              reply_avatar : '',
            };
            this.reply_data.push(temp);
            this.getAvatar(i,element.user_id,1);
            i+=1;
          });
          this.$forceUpdate();
        })
        .catch((error)=>{
          console.log(error);
        });
    },
    DeleteReply:function(index)
    {
      let reply_id = this.reply_data[index].reply_id;
      let poster_id = this.reply_data[index].reply_user_id;
      if(this.$store.getters.getRole=='admin' || this.cur_user==poster_id)
      {
        this.$axios.post('/api/forum/delete-reply',{
          reply_id : reply_id,
          user_id : this.cur_user,
          delete_timestamp : 14000
        })
          .then((response)=>{
            this.GetReplyList();
          })
          .catch((error)=>{
            console.log(error);
          });
      }
      else
      {
        this.$message('仅管理员与内容发布者具有删除权限');
      }
    },
    LikeReply:function(index, type)
    {
      let reply_id = this.reply_data[index].reply_id;
      this.$axios.post('/api/forum/like-reply',{
        reply_id : reply_id,
        user_id : this.cur_user,
        like_type : type?1:0
      })
        .then((response)=>{
          this.$set(this.reply_data[index], 'reply_like_state', response.data.like_state);
          this.$set(this.reply_data[index], 'reply_like_count', this.reply_data[index].reply_like_count + (type?1:(-1)));
          //这样写合适吗
        })
        .catch((error)=>{
          console.log(error);
        });
    },
    AddReply:function()
    {
      if(!this.high_privelege && this.editor.getText().length>=5)
      {
        this.$axios.post('/api/forum/add-reply',{
          question_id : this.post_id,
          reply_content : this.reply_input,
          user_id : this.cur_user,
          reply_stamp : 14000,
          image_list : this.reply_image_list,
        })
          .then((response)=>{
            this.reply_input = '';
            this.reply_image_list = [];
            this.GetReplyList();
          })
          .catch((error)=>{
            console.log(error);
          });
      }
      else if(this.high_privelege)
      {
        this.$message('仅学生具有回复权限');
      }
      else if(this.editor.getText().length<5)
      {
        this.$message('回复长度至少应为5');
      }
    },

    LikeQuestion:function(post_id, type)
    {
      this.$axios.post('/api/forum/like-question',
      {
        question_id : post_id,
        user_id : this.cur_user,
        like_type : type?1:0
      })
        .then((response)=>{
          this.$set(this.msg_data, 'msg_like_state', response.data.like_state);
          this.$set(this.msg_data, 'msg_like_count', this.msg_data.msg_like_count + (type?1:(-1)));
        })
        .catch((error)=>{
          console.log(error);
        });
    },
    StickQuestion:function(type)
    {
      if(this.high_privelege){
        this.$axios.post('/api/forum/stick-question',
        {
          question_id : this.post_id,
          user_id : this.cur_user,
          stick_type : type?1:0
        })
          .then((response)=>
          {
            this.$set(this.msg_data, 'msg_stick_state', response.data.stick_state);
          })
          .catch((error)=>
          {
            console.log(error);
          });
      }
      else{
        this.$message('仅教师/管理员具有置顶权限');
      }
    },
    DeleteQuestion:function()
    {
      if(this.high_privelege || this.cur_user==this.msg_data.msg_profile_name)
      {
        this.$axios.post('/api/forum/delete-question',
        {
          question_id : this.post_id,
          user_id : this.cur_user,
          delete_timestamp : 14000
        })
          .then((response)=>{
            this.EnterForum();
          })
          .catch((error)=>{
            console.log(error);
          });
      }
      else{
        this.$message('仅教师/管理员与内容发布者具有删除权限');
      }
    },
  },

  computed: 
  {
  },

  components: 
  {
    Editor,
    Toolbar,
  },

  created: function()
  {
    this.GetReplyList();
  },
  beforeDestroy(){
    const editor = this.editor;
    if(editor == null)
      return;
    editor.destroy();
  },
};
</script>


<style scoped>
.maxsize >>> * 
{
  max-height: 100% ;
  max-width: 100% ;
}
.msg-block 
{
  min-height:150px;
}
.ans-block 
{
  min-height:120px;
}
.align-left
{
  text-align:left;
}
.text
{
  text-align:left;
  font-family:"Microsoft YaHei";
}
.post-head 
{
  font-size:20px;
}
.post-content 
{
  font-size:15px;
}
.post-time 
{
  font-size:15px;
}
.post-username 
{
  font-size:15px;
}
.post-info 
{
  font-size:20px;
}
.inline
{
  display:inline;
  float:left;
}
.like-icon 
{
  cursor: pointer;
}
.liked 
{
  color: red;
}
</style>
